NMSettingTeamPort: libnm Reference Manual

## NMSettingTeamPort NMSettingTeamPort — Describes connection properties for team ports |

## Functions

NMSetting * | nm_setting_team_port_new ()
const char * | nm_setting_team_port_get_config ()
int | nm_setting_team_port_get_queue_id ()
int | nm_setting_team_port_get_prio ()
gboolean | nm_setting_team_port_get_sticky ()
int | nm_setting_team_port_get_lacp_prio ()
int | nm_setting_team_port_get_lacp_key ()
guint | nm_setting_team_port_get_num_link_watchers ()
NMTeamLinkWatcher * | nm_setting_team_port_get_link_watcher ()
gboolean | nm_setting_team_port_add_link_watcher ()
void | nm_setting_team_port_remove_link_watcher ()
gboolean | nm_setting_team_port_remove_link_watcher_by_value ()
void | nm_setting_team_port_clear_link_watchers ()

## Properties

char * | config | Read / Write
int | lacp-key | Read / Write
int | lacp-prio | Read / Write
GPtrArray * | link-watchers | Read / Write
int | prio | Read / Write
int | queue-id | Read / Write
gboolean | sticky | Read / Write

## Types and Values

#define | NM_SETTING_TEAM_PORT_SETTING_NAME
#define | NM_SETTING_TEAM_PORT_CONFIG
#define | NM_SETTING_TEAM_PORT_QUEUE_ID
#define | NM_SETTING_TEAM_PORT_PRIO
#define | NM_SETTING_TEAM_PORT_STICKY
#define | NM_SETTING_TEAM_PORT_LACP_PRIO
#define | NM_SETTING_TEAM_PORT_LACP_KEY
#define | NM_SETTING_TEAM_PORT_LINK_WATCHERS
#define | NM_SETTING_TEAM_PORT_QUEUE_ID_DEFAULT
#define | NM_SETTING_TEAM_PORT_LACP_PRIO_DEFAULT
| NMSettingTeamPort

## Object Hierarchy

        GObject
        ╰── NMSetting
            ╰── NMSettingTeamPort

## Description

The NMSettingTeamPort object is a NMSetting subclass that describes optional properties that apply to team ports.

## Functions

### nm_setting_team_port_new ()

    NMSetting *
    nm_setting_team_port_new (void);

Creates a new NMSettingTeamPort object with default values.

#### Returns

the new empty NMSettingTeamPort object.

[transfer full]

### nm_setting_team_port_get_config ()

    const char *
    nm_setting_team_port_get_config (NMSettingTeamPort *setting);

#### Parameters

setting | the NMSettingTeamPort |

#### Returns

the “config” property of the setting

### nm_setting_team_port_get_queue_id ()

    int
    nm_setting_team_port_get_queue_id (NMSettingTeamPort *setting);

#### Parameters

setting | the NMSettingTeamPort |

#### Returns

the “queue_id” property of the setting

Since: 1.12

### nm_setting_team_port_get_prio ()

    int
    nm_setting_team_port_get_prio (NMSettingTeamPort *setting);

#### Parameters

setting | the NMSettingTeamPort |

#### Returns

the “prio” property of the setting

Since: 1.12

### nm_setting_team_port_get_sticky ()

    gboolean
    nm_setting_team_port_get_sticky (NMSettingTeamPort *setting);

#### Parameters

setting | the NMSettingTeamPort |

#### Returns

the “sticky” property of the setting

Since: 1.12

### nm_setting_team_port_get_lacp_prio ()

    int
    nm_setting_team_port_get_lacp_prio (NMSettingTeamPort *setting);

#### Parameters

setting | the NMSettingTeamPort |

#### Returns

the “lacp-prio” property of the setting

Since: 1.12

### nm_setting_team_port_get_lacp_key ()

    int
    nm_setting_team_port_get_lacp_key (NMSettingTeamPort *setting);

#### Parameters

setting | the NMSettingTeamPort |

#### Returns

the “lacp-key” property of the setting

Since: 1.12

### nm_setting_team_port_get_num_link_watchers ()

    guint
    nm_setting_team_port_get_num_link_watchers
                                   (NMSettingTeamPort *setting);

#### Parameters

setting | the NMSettingTeamPort |

#### Returns

the number of configured link watchers

Since: 1.12

### nm_setting_team_port_get_link_watcher ()

    NMTeamLinkWatcher *
    nm_setting_team_port_get_link_watcher (NMSettingTeamPort *setting,
                                           guint idx);

#### Parameters

setting | the NMSettingTeamPort |
idx | index number of the link watcher to return |

#### Returns

the link watcher at index `idx` .

[transfer none]

Since: 1.12

### nm_setting_team_port_add_link_watcher ()

    gboolean
    nm_setting_team_port_add_link_watcher (NMSettingTeamPort *setting,
                                           NMTeamLinkWatcher *link_watcher);

Appends a new link watcher to the setting.

#### Parameters

setting | the NMSettingTeamPort |
link_watcher | the link watcher to add |

#### Returns

`TRUE` if the link watcher is added; `FALSE` if an identical link watcher was already there.

Since: 1.12

### nm_setting_team_port_remove_link_watcher ()

    void
    nm_setting_team_port_remove_link_watcher
                                   (NMSettingTeamPort *setting,
                                    guint idx);

Removes the link watcher at index idx.

#### Parameters

setting | the NMSettingTeamPort |
idx | index number of the link watcher to remove |

Since: 1.12

### nm_setting_team_port_remove_link_watcher_by_value ()

    gboolean
    nm_setting_team_port_remove_link_watcher_by_value
                                   (NMSettingTeamPort *setting,
                                    NMTeamLinkWatcher *link_watcher);

Removes the link watcher entry matching link_watcher.

#### Parameters

setting | the NMSettingTeamPort |
link_watcher | the link watcher to remove |

#### Returns

`TRUE` if the link watcher was found and removed, `FALSE` otherwise.

Since: 1.12

### nm_setting_team_port_clear_link_watchers ()

    void
    nm_setting_team_port_clear_link_watchers
                                   (NMSettingTeamPort *setting);

Removes all configured link watchers.

#### Parameters

setting | the NMSettingTeamPort |

Since: 1.12

## Types and Values

### NM_SETTING_TEAM_PORT_SETTING_NAME

    #define NM_SETTING_TEAM_PORT_SETTING_NAME "team-port"

### NM_SETTING_TEAM_PORT_CONFIG

    #define NM_SETTING_TEAM_PORT_CONFIG        "config"

### NM_SETTING_TEAM_PORT_QUEUE_ID

    #define NM_SETTING_TEAM_PORT_QUEUE_ID      "queue-id"

### NM_SETTING_TEAM_PORT_PRIO

    #define NM_SETTING_TEAM_PORT_PRIO          "prio"

### NM_SETTING_TEAM_PORT_STICKY

    #define NM_SETTING_TEAM_PORT_STICKY        "sticky"

### NM_SETTING_TEAM_PORT_LACP_PRIO

    #define NM_SETTING_TEAM_PORT_LACP_PRIO     "lacp-prio"

### NM_SETTING_TEAM_PORT_LACP_KEY

    #define NM_SETTING_TEAM_PORT_LACP_KEY      "lacp-key"

### NM_SETTING_TEAM_PORT_LINK_WATCHERS

    #define NM_SETTING_TEAM_PORT_LINK_WATCHERS "link-watchers"

### NM_SETTING_TEAM_PORT_QUEUE_ID_DEFAULT

    #define NM_SETTING_TEAM_PORT_QUEUE_ID_DEFAULT  -1

### NM_SETTING_TEAM_PORT_LACP_PRIO_DEFAULT

    #define NM_SETTING_TEAM_PORT_LACP_PRIO_DEFAULT 255

### NMSettingTeamPort

    typedef struct _NMSettingTeamPort NMSettingTeamPort;

Team Port Settings

## Property Details

### The `“config”` property

      “config”                   char *

The JSON configuration for the team port. The property should contain raw JSON configuration data suitable for teamd, because the value is passed directly to teamd. If not specified, the default configuration is used. See man teamd.conf for the format details.

Owner: NMSettingTeamPort

Flags: Read / Write

Default value: NULL

### The `“lacp-key”` property

      “lacp-key”                 int

Corresponds to the teamd ports.PORTIFNAME.lacp_key.

Owner: NMSettingTeamPort

Flags: Read / Write

Default value: -1

Since: 1.12

### The `“lacp-prio”` property

      “lacp-prio”                int

Corresponds to the teamd ports.PORTIFNAME.lacp_prio.

Owner: NMSettingTeamPort

Flags: Read / Write

Default value: -1

Since: 1.12

### The `“link-watchers”` property

      “link-watchers”            GPtrArray *

Link watchers configuration for the connection: each link watcher is defined by a dictionary, whose keys depend upon the selected link watcher. Available link watchers are 'ethtool', 'nsna_ping' and 'arp_ping' and it is specified in the dictionary with the key 'name'. Available keys are: ethtool: 'delay-up', 'delay-down', 'init-wait'; nsna_ping: 'init-wait', 'interval', 'missed-max', 'target-host'; arp_ping: all the ones in nsna_ping and 'source-host', 'validate-active', 'validate-inactive', 'send-always'. See teamd.conf man for more details.

[type GPtrArray(NMTeamLinkWatcher)]

Owner: NMSettingTeamPort

Flags: Read / Write

Since: 1.12

### The `“prio”` property

      “prio”                     int

Corresponds to the teamd ports.PORTIFNAME.prio.

Owner: NMSettingTeamPort

Flags: Read / Write

Default value: 0

Since: 1.12

### The `“queue-id”` property

      “queue-id”                 int

Corresponds to the teamd ports.PORTIFNAME.queue_id. When set to -1 means the parameter is skipped from the json config.

Owner: NMSettingTeamPort

Flags: Read / Write

Default value: -1

Since: 1.12

### The `“sticky”` property

      “sticky”                   gboolean

Corresponds to the teamd ports.PORTIFNAME.sticky.

Owner: NMSettingTeamPort

Flags: Read / Write

Default value: FALSE

Since: 1.12